com.io7m.jtensors.core.parameterized.matrices

## Class PMatrix4x4D<A,B>

- java.lang.Object
- - com.io7m.jtensors.core.parameterized.matrices.PMatrix4x4D<A,B>

- Type Parameters:
    `A` - A phantom type parameter (possibly representing a source coordinate system)
    `B` - A phantom type parameter (possibly representing a target coordinate system)
  All Implemented Interfaces:
    MatrixComputationalType, PMatrix4x4DType<A,B>, PMatrixReadable4x4DType<A,B>, MatrixReadable4x4DType, MatrixReadableDType

      @Generated(value={"Immutables.generator","PMatrix4x4DType<A, B>"})
      public final class PMatrix4x4D<A,B>
      extends Object
      implements PMatrix4x4DType<A,B>

  The type of 4x4 `double`-typed matrices.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `PMatrix4x4D.Builder<A,B>` Builds instances of type `PMatrix4x4D`.

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static <A,B> PMatrix4x4D.Builder<A,B>` | `builder()` Creates a builder for `PMatrix4x4D`.
    `boolean` | `equals(Object another)` This instance is equal to all instances of `PMatrix4x4D` that have equal attribute values.
    `int` | `hashCode()` Computes a hash code from attributes: `r0c0`, `r0c1`, `r0c2`, `r0c3`, `r1c0`, `r1c1`, `r1c2`, `r1c3`, `r2c0`, `r2c1`, `r2c2`, `r2c3`, `r3c0`, `r3c1`, `r3c2`, `r3c3`.
    `static <A,B> PMatrix4x4D<A,B>` | `of(double r0c0, double r0c1, double r0c2, double r0c3, double r1c0, double r1c1, double r1c2, double r1c3, double r2c0, double r2c1, double r2c2, double r2c3, double r3c0, double r3c1, double r3c2, double r3c3)` Construct a new immutable `PMatrix4x4D` instance.
    `double` | `r0c0()`
    `double` | `r0c1()`
    `double` | `r0c2()`
    `double` | `r0c3()`
    `double` | `r1c0()`
    `double` | `r1c1()`
    `double` | `r1c2()`
    `double` | `r1c3()`
    `double` | `r2c0()`
    `double` | `r2c1()`
    `double` | `r2c2()`
    `double` | `r2c3()`
    `double` | `r3c0()`
    `double` | `r3c1()`
    `double` | `r3c2()`
    `double` | `r3c3()`
    `String` | `toString()` Prints the immutable value `PMatrix4x4D` with attribute values.

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface com.io7m.jtensors.core.unparameterized.matrices.MatrixReadable4x4DType

      `rowColumn`

- - ### Method Detail

    - #### r0c0

          public double r0c0()

      Specified by:
        `r0c0` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r0c0` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 0 column 0

    - #### r0c1

          public double r0c1()

      Specified by:
        `r0c1` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r0c1` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 0 column 1

    - #### r0c2

          public double r0c2()

      Specified by:
        `r0c2` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r0c2` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 0 column 2

    - #### r0c3

          public double r0c3()

      Specified by:
        `r0c3` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r0c3` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 0 column 3

    - #### r1c0

          public double r1c0()

      Specified by:
        `r1c0` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r1c0` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 1 column 0

    - #### r1c1

          public double r1c1()

      Specified by:
        `r1c1` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r1c1` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 1 column 1

    - #### r1c2

          public double r1c2()

      Specified by:
        `r1c2` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r1c2` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 1 column 2

    - #### r1c3

          public double r1c3()

      Specified by:
        `r1c3` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r1c3` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 1 column 3

    - #### r2c0

          public double r2c0()

      Specified by:
        `r2c0` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r2c0` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 2 column 0

    - #### r2c1

          public double r2c1()

      Specified by:
        `r2c1` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r2c1` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 2 column 1

    - #### r2c2

          public double r2c2()

      Specified by:
        `r2c2` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r2c2` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 2 column 2

    - #### r2c3

          public double r2c3()

      Specified by:
        `r2c3` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r2c3` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 2 column 3

    - #### r3c0

          public double r3c0()

      Specified by:
        `r3c0` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r3c0` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 3 column 0

    - #### r3c1

          public double r3c1()

      Specified by:
        `r3c1` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r3c1` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 3 column 1

    - #### r3c2

          public double r3c2()

      Specified by:
        `r3c2` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r3c2` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 3 column 2

    - #### r3c3

          public double r3c3()

      Specified by:
        `r3c3` in interface `PMatrix4x4DType<A,B>`
      Specified by:
        `r3c3` in interface `MatrixReadable4x4DType`
      Returns:
        The value at row 3 column 3

    - #### equals

          public boolean equals(Object another)

      This instance is equal to all instances of `PMatrix4x4D` that have equal attribute values.
      Overrides:
        `equals` in class `Object`
      Returns:
        `true` if `this` is equal to `another` instance

    - #### hashCode

          public int hashCode()

      Computes a hash code from attributes: `r0c0`, `r0c1`, `r0c2`, `r0c3`, `r1c0`, `r1c1`, `r1c2`, `r1c3`, `r2c0`, `r2c1`, `r2c2`, `r2c3`, `r3c0`, `r3c1`, `r3c2`, `r3c3`.
      Overrides:
        `hashCode` in class `Object`
      Returns:
        hashCode value

    - #### toString

          public String toString()

      Prints the immutable value `PMatrix4x4D` with attribute values.
      Overrides:
        `toString` in class `Object`
      Returns:
        A string representation of the value

    - #### of

          public static <A,B> PMatrix4x4D<A,B> of(double r0c0,
                                                  double r0c1,
                                                  double r0c2,
                                                  double r0c3,
                                                  double r1c0,
                                                  double r1c1,
                                                  double r1c2,
                                                  double r1c3,
                                                  double r2c0,
                                                  double r2c1,
                                                  double r2c2,
                                                  double r2c3,
                                                  double r3c0,
                                                  double r3c1,
                                                  double r3c2,
                                                  double r3c3)

      Construct a new immutable `PMatrix4x4D` instance.
      Parameters:
        `r0c0` - The value for the `r0c0` attribute
        `r0c1` - The value for the `r0c1` attribute
        `r0c2` - The value for the `r0c2` attribute
        `r0c3` - The value for the `r0c3` attribute
        `r1c0` - The value for the `r1c0` attribute
        `r1c1` - The value for the `r1c1` attribute
        `r1c2` - The value for the `r1c2` attribute
        `r1c3` - The value for the `r1c3` attribute
        `r2c0` - The value for the `r2c0` attribute
        `r2c1` - The value for the `r2c1` attribute
        `r2c2` - The value for the `r2c2` attribute
        `r2c3` - The value for the `r2c3` attribute
        `r3c0` - The value for the `r3c0` attribute
        `r3c1` - The value for the `r3c1` attribute
        `r3c2` - The value for the `r3c2` attribute
        `r3c3` - The value for the `r3c3` attribute
      Returns:
        An immutable PMatrix4x4D instance

    - #### builder

          public static <A,B> PMatrix4x4D.Builder<A,B> builder()

      Creates a builder for `PMatrix4x4D`.
      Type Parameters:
        `A` - generic parameter A
        `B` - generic parameter B
      Returns:
        A new PMatrix4x4D builder

Copyright © 2017 <code@io7m.com> http://io7m.com